#!/usr/bin/env python
from gimpfu import *

def GraphicaABC(inImage, inDrawable, outStrength):
    
    pdb.gimp_context_push
    pdb.gimp_image_undo_group_start (inImage)
    
    cutoff = 223    # base=cleanest
    cutoff = cutoff + outStrength*4
    
    Desat = inDrawable.copy()
    inImage.add_layer (Desat, 0)
    Desat.mode = NORMAL_MODE
    Desat.name = "Desat"
    pdb.gimp_desaturate (Desat)
    pdb.gimp_levels (Desat, HISTOGRAM_VALUE, 0, 255, 0.70, 0, 255)
    
    Blur = Desat.copy()
    inImage.add_layer (Blur, 0)
    pdb.gimp_invert (Blur)
    Blur.mode = DODGE_MODE
    x_blur = Blur.width/85
    y_blur = Blur.height/85
    pdb.plug_in_gauss_iir2 (inImage, Blur, x_blur, y_blur)
    Blur.name = "Blur"
    
    Graphica = pdb.gimp_layer_new_from_visible (inImage, inImage, "Graphica "+str(cutoff))
    inImage.add_layer (Graphica, 0)
    Graphica.mode = NORMAL_MODE
        
    pdb.gimp_threshold (Graphica, cutoff, 255) # chosen
    
    pdb.gimp_image_undo_group_end (inImage)
    pdb.gimp_context_pop
    pdb.gimp_displays_flush()
    return()
    
register(
    "GraphicaABC",   "GraphicaABC",         "GraphicaABC",
    "Diego",         "Diego Nassetti ",     "2017",
    "GraphicaABC",
    "RGB*",
    [
      (PF_IMAGE, "image", "Input image", None),
      (PF_DRAWABLE, "idrawable", "Input drawable", None),
      (PF_OPTION, "strength", "Output strength", 2, ("Cleanest", "Cleaner", "Standard", "Stronger", "Strongest")),
    ],
    [],
    GraphicaABC,
    menu="<Image>/Diego/Ancillary",
    )

main()
